function [bars,barStruct] = findBars(barStruct, nl)

bars = [];

if(isempty(barStruct))
    return;
end

%% Sort Bars according to NFA
[~, ind] = sort(barStruct(:,5));

C = barStruct;

for i=1:length(ind)
    barStruct(i,:) = C(ind(i),:);
end


%%  

nb = size(barStruct,1);
lb = cell(nl, 1);

for b=1:nb
    lb{barStruct(b,1)} = [lb{barStruct(b,1)} b]; %First line in bar
    lb{barStruct(b,2)} = [lb{barStruct(b,2)} b]; %Second line in bar
    
end

%%

nbar = 0;
bars = []; 
eps = 1;

valid = ones(nb,1);

for b=1:nb
    if(barStruct(b,5)<eps)
        if(valid(b))
            nbar = nbar + 1;
            bars{nbar} = [barStruct(b,1) barStruct(b,2)];
            barStruct(b,6) = nbar;
            valid(b) = 0;
            
            %remove subchains
            for l=1:length(bars{nbar})
                li = bars{nbar}(l);
                for c1=1:length(lb{li})
                    valid(lb{li}(c1)) = 0;
                end
            end
            
        end
    else
        return;
    end
end

