function [adjMatrix] = makeAdjMatrix_Bar(segs,rho)

nL = sum([segs.type]<3);
adjMatrix = cell(nL,1);

for i=1:nL        
    for j=i+1:nL
        
        [r, t] = isAdjacent_Bar(segs(i),segs(j),rho);
        if (r~=-1)
            ind = size(adjMatrix{i}, 1)+1;
            adjMatrix{i}(ind, 1) = j;
            adjMatrix{i}(ind, 2) = r;
            adjMatrix{i}(ind, 3) = t;        
            
            ind = size(adjMatrix{j}, 1)+1;
            adjMatrix{j}(ind, 1) = i;
            adjMatrix{j}(ind, 2) = r;
            adjMatrix{j}(ind, 3) = t;   
            
        end
        
    end
    
end
